<!DOCTYPE html>
<html lang="en">
<head>

    <!-- CONFETTI DOCS: https://www.cssscript.com/confetti-falling-animation/ -->

    <!-- Page title -->
    <title>Pexeso</title>

    <!-- Meta tags -->
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <!-- Bootstrap -->
    <link 
        href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" 
        rel="stylesheet" 
        integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" 
        crossorigin="anonymous"
    >

    <!-- Custom styling -->
    <style>
        ::-webkit-scrollbar {
            width: 10px;
        }
        ::-webkit-scrollbar-track {
            background: #f1f1f1; 
        }
        ::-webkit-scrollbar-thumb {
            background: #888; 
        }
        ::-webkit-scrollbar-thumb:hover {
            background: #555; 
        }
        #new-game {
            display: none;
            position: fixed;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            border: 0px;
            background-color: whitesmoke;
            display: inline-block;
            width: 120px;
            height: 120px;
            border-radius: 50%;
            display: none;
        }
        .upload-images {
            background-color: whitesmoke;
            display: inline-block;
            width: 120px;
            height: 120px;
            border-radius: 50%;
            display: flex;
            align-items: center;
            justify-content: center;
            cursor: pointer;
        }
        #images {
            display: none;
        }
        body {
            background-color: #0e0e0e;
        }
        .uploading-holder {
            background-color: #0e0e0e;
            position: fixed;
            left: 0;
            top: 0;
            height: 100%;
            width: 100%;
        }
        .center-aligning {
            display: flex;
            align-items: center;
            justify-content: center;
            height: 100%;
        }
        #confetti-canvas {
            position: fixed;
            z-index: 99;
            left: 0;
            top: 0;
            width: 100%;
            height: 100%;
        }
        #done {
            font-family: 'Press Start 2P';
            color: white;
            font-size: 35px;
            position: fixed;
            position: fixed;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
            text-align: center;
        }
        .play-icon {
            background-color: whitesmoke;
            display: inline-block;
            width: 120px;
            height: 120px;
            border-radius: 50%;
            display: flex;
            align-items: center;
            justify-content: center;
            cursor: pointer;
            margin: 0px auto;
        }
        .play-icon svg {
            color: black;
            width: 30px;
            height: 30px;
        }
        #pexeso {
            transition: 1s all;
        }
        #done {
            opacity: 0;
        }
    </style>

</head>
<body>

    <!-- New game button -->
    <button 
        id="new-game"
        onclick="location.reload();" 
        class="d-none"
    >
        <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" fill="currentColor" class="bi bi-arrow-clockwise" viewBox="0 0 16 16">
            <path fill-rule="evenodd" d="M8 3a5 5 0 1 0 4.546 2.914.5.5 0 0 1 .908-.417A6 6 0 1 1 8 2v1z"/>
            <path d="M8 4.466V.534a.25.25 0 0 1 .41-.192l2.36 1.966c.12.1.12.284 0 .384L8.41 4.658A.25.25 0 0 1 8 4.466z"/>
        </svg>
    </button>


    <!-- Image for uploading -->
    <div id="upload-holder" class="uploading-holder">
        <div class="center-aligning"> 
            <div id="upload-images" class="upload-images" onclick="document.getElementById('images').click()">
                <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" fill="currentColor" class="bi bi-cloud-upload" viewBox="0 0 16 16">
                    <path fill-rule="evenodd" d="M4.406 1.342A5.53 5.53 0 0 1 8 0c2.69 0 4.923 2 5.166 4.579C14.758 4.804 16 6.137 16 7.773 16 9.569 14.502 11 12.687 11H10a.5.5 0 0 1 0-1h2.688C13.979 10 15 8.988 15 7.773c0-1.216-1.02-2.228-2.313-2.228h-.5v-.5C12.188 2.825 10.328 1 8 1a4.53 4.53 0 0 0-2.941 1.1c-.757.652-1.153 1.438-1.153 2.055v.448l-.445.049C2.064 4.805 1 5.952 1 7.318 1 8.785 2.23 10 3.781 10H6a.5.5 0 0 1 0 1H3.781C1.708 11 0 9.366 0 7.318c0-1.763 1.266-3.223 2.942-3.593.143-.863.698-1.723 1.464-2.383z"/>
                    <path fill-rule="evenodd" d="M7.646 4.146a.5.5 0 0 1 .708 0l3 3a.5.5 0 0 1-.708.708L8.5 5.707V14.5a.5.5 0 0 1-1 0V5.707L5.354 7.854a.5.5 0 1 1-.708-.708l3-3z"/>
                </svg>
            </div>
        </div>
    </div>

    <!-- Put content into container -->
    <div class="container pt-4">

        <!-- Image uploader -->
        <input 
            id="images"
            type="file" 
            multiple="multiple" 
            accept="image/jpeg, image/png, image/jpg"
            class="form-control"
        >

        <!-- Playing area -->
        <div class="row" id="pexeso">

        </div>

        <!-- Play again -->
        <div id="done" class="d-none">
            <div class="play-holder">
                <a href="/">
                    <div class="play-icon">
                        <svg xmlns="http://www.w3.org/2000/svg" width="30" height="30" fill="currentColor" class="bi bi-arrow-clockwise" viewBox="0 0 16 16">
                            <path fill-rule="evenodd" d="M8 3a5 5 0 1 0 4.546 2.914.5.5 0 0 1 .908-.417A6 6 0 1 1 8 2v1z"/>
                            <path d="M8 4.466V.534a.25.25 0 0 1 .41-.192l2.36 1.966c.12.1.12.284 0 .384L8.41 4.658A.25.25 0 0 1 8 4.466z"/>
                          </svg>
                    </div>
                </a>
            </div>
        </div>

    </div>

    <!-- Bootstrap -->
    <script 
        src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/js/bootstrap.bundle.min.js" 
        integrity="sha384-geWF76RCwLtnZ8qwWowPQNguL3RmwHVBC9FhGdlKrxdiJJigb/j/68SIy3Te4Bkz" 
        crossorigin="anonymous"
    ></script>

    <!-- Game script -->
    <script>

        /** Prepare variables for cards */
        let one = "nothing";
        let two = "nothing";

        /** Count remaining */
        let remaining = null;

        /** Loading */
        let loading = false;

        /** Prepare variable tracking clicks */
        let firstCard = true;

        /** Prepare array for images */
        let images = [];
    
        /** When images are selected */
        document.querySelector("input").addEventListener("change", function() {
    
            /** Extract them */
            Array.from(document.querySelector("input").files).forEach(function(file) {
                remaining = remaining + 1;
                images.push(URL.createObjectURL(file));
            });

            /** Remove input */
            document.getElementById("images").remove();
            document.getElementById("upload-holder").remove();

            /** Show new game button */
            document.getElementById("new-game").classList.remove("d-none");
                
            /** Prepare them for game */
            duplicateImages();
            shuffleImages();
    
            /** Render images */
            renderImages();
    
        });
    
        function duplicateImages()
        {
            images.forEach(function(image){
                images.push(image);
            });
        }
    
        function shuffleImages() 
        {
            for (let i = images.length - 1; i > 0; i--) {
                const j = Math.floor(Math.random() * (i + 1));
                [images[i], images[j]] = [images[j], images[i]];
            }
        }
    
        function renderImages() 
        {
            images.forEach(function(image){

                /** Generate class */
                let class_name = "image-" + (Math.floor(Math.random() * (9999999 - 1111111)) + 1111111);
              
                /** Handle parent div */
                let div = document.createElement("div");
                div.classList.add("col-6", "col-md-4", "col-lg-3");

                /** Handle card */
                let card = document.createElement("div");
                card.classList.add("mb-4", "bg-white", "rounded");
                card.style.aspectRatio = "1/1";
                card.style.cursor = "pointer";
                card.style.display = "flex";
                card.style.justifyContent = "center";
                card.style.alignItems = "center";
                card.style.backgroundSize = "cover";
                card.style.backgroundPosition = "center";
                card.setAttribute("id", class_name);
                card.setAttribute("blob", image);
                card.innerHTML = `
                    <svg xmlns="http://www.w3.org/2000/svg" width="40" height="40" fill="currentColor" class="bi bi-image" viewBox="0 0 16 16">
                        <path d="M6.002 5.5a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0z"/>
                        <path d="M2.002 1a2 2 0 0 0-2 2v10a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V3a2 2 0 0 0-2-2h-12zm12 1a1 1 0 0 1 1 1v6.5l-3.777-1.947a.5.5 0 0 0-.577.093l-3.71 3.71-2.66-1.772a.5.5 0 0 0-.63.062L1.002 12V3a1 1 0 0 1 1-1h12z"/>
                    </svg>
                `;

                /** Append card to parent */
                div.append(card);

                /** Create cards */
                document.getElementById("pexeso").append(div);

                /** Add event listener for clicks */
                div.addEventListener("click", function(){

                    if(!loading) {

                        /** Show image */
                        card.style.backgroundImage = "url('" + card.getAttribute("blob") + "')";

                        /** Hide icon */
                        document.querySelectorAll("#" + card.getAttribute("id") + " svg")[0].style.display = "none";

                        /** If it is first card that was opened */
                        if(firstCard) {
                            if(!loading) {
                                one = card;
                                firstCard = !firstCard;
                            }
                        } 
                        
                        /** If it is second card */
                        else {
                            if(card != one) {
                                loading = true;
                                two = card;
                                if(one.getAttribute("blob") == two.getAttribute("blob")) {
                                    remaining = remaining - 1;
                                    firstCard = true;
                                    loading = false;
                                    if(remaining == 0) {
                                        startConfetti();
                                        document.getElementById("pexeso").style.opacity = 0;
                                        setTimeout(function(){
                                            document.getElementById("done").classList.remove("d-none");
                                            document.getElementById("done").style.opacity = 1;
                                        }, 500);
                                    } else {
                                        startConfetti();
                                        setTimeout(function(){
                                            stopConfetti();
                                        }, 1000);
                                    }
                                } else {
                                    setTimeout(function(){
                                        one.style.backgroundImage = "none";
                                        two.style.backgroundImage = "none";
                                        document.querySelectorAll("#" + one.getAttribute("id") + " svg")[0].style.display = "block";
                                        document.querySelectorAll("#" + two.getAttribute("id") + " svg")[0].style.display = "block";
                                        firstCard = !firstCard;
                                        loading = false;
                                    }, 1200);
                                }
                            } 
                        }

                    }

                });
            });
        }

        
            
    </script>

    <script>

        var maxParticleCount = 150; //set max confetti count
        var particleSpeed = 2; //set the particle animation speed
        var startConfetti; //call to start confetti animation
        var stopConfetti; //call to stop adding confetti
        var toggleConfetti; //call to start or stop the confetti animation depending on whether it's already running
        var removeConfetti; //call to stop the confetti animation and remove all confetti immediately

        (function() {
            startConfetti = startConfettiInner;
            stopConfetti = stopConfettiInner;
            toggleConfetti = toggleConfettiInner;
            removeConfetti = removeConfettiInner;
            var colors = ["DodgerBlue", "OliveDrab", "Gold", "Pink", "SlateBlue", "LightBlue", "Violet", "PaleGreen", "SteelBlue", "SandyBrown", "Chocolate", "Crimson"]
            var streamingConfetti = false;
            var animationTimer = null;
            var particles = [];
            var waveAngle = 0;
            
            function resetParticle(particle, width, height) {
                particle.color = colors[(Math.random() * colors.length) | 0];
                particle.x = Math.random() * width;
                particle.y = Math.random() * height - height;
                particle.diameter = Math.random() * 10 + 5;
                particle.tilt = Math.random() * 10 - 10;
                particle.tiltAngleIncrement = Math.random() * 0.07 + 0.05;
                particle.tiltAngle = 0;
                return particle;
            }

            function startConfettiInner() {
                var width = window.innerWidth;
                var height = window.innerHeight;
                window.requestAnimFrame = (function() {
                    return window.requestAnimationFrame ||
                        window.webkitRequestAnimationFrame ||
                        window.mozRequestAnimationFrame ||
                        window.oRequestAnimationFrame ||
                        window.msRequestAnimationFrame ||
                        function (callback) {
                            return window.setTimeout(callback, 16.6666667);
                        };
                })();
                var canvas = document.getElementById("confetti-canvas");
                if (canvas === null) {
                    canvas = document.createElement("canvas");
                    canvas.setAttribute("id", "confetti-canvas");
                    canvas.setAttribute("style", "display:block;z-index:999999;pointer-events:none");
                    document.body.appendChild(canvas);
                    canvas.width = width;
                    canvas.height = height;
                    window.addEventListener("resize", function() {
                        canvas.width = window.innerWidth;
                        canvas.height = window.innerHeight;
                    }, true);
                }
                var context = canvas.getContext("2d");
                while (particles.length < maxParticleCount)
                    particles.push(resetParticle({}, width, height));
                    streamingConfetti = true;
                    if (animationTimer === null) {
                        (function runAnimation() {
                            context.clearRect(0, 0, window.innerWidth, window.innerHeight);
                            if (particles.length === 0)
                                animationTimer = null;
                            else {
                                updateParticles();
                                drawParticles(context);
                                animationTimer = requestAnimFrame(runAnimation);
                            }
                        })();
                    }
                }

                function stopConfettiInner() {
                    streamingConfetti = false;
                }

                function removeConfettiInner() {
                    stopConfetti();
                    particles = [];
                }

                function toggleConfettiInner() {
                    if (streamingConfetti)
                        stopConfettiInner();
                    else
                        startConfettiInner();
                }

                function drawParticles(context) {
                    var particle;
                    var x;
                    for (var i = 0; i < particles.length; i++) {
                        particle = particles[i];
                        context.beginPath();
                        context.lineWidth = particle.diameter;
                        context.strokeStyle = particle.color;
                        x = particle.x + particle.tilt;
                        context.moveTo(x + particle.diameter / 2, particle.y);
                        context.lineTo(x, particle.y + particle.tilt + particle.diameter / 2);
                        context.stroke();
                    }
                }

                function updateParticles() {
                    var width = window.innerWidth;
                    var height = window.innerHeight;
                    var particle;
                    waveAngle += 0.01;
                    for (var i = 0; i < particles.length; i++) {
                        particle = particles[i];
                        if (!streamingConfetti && particle.y < -15)
                            particle.y = height + 100;
                        else {
                            particle.tiltAngle += particle.tiltAngleIncrement;
                            particle.x += Math.sin(waveAngle);
                            particle.y += (Math.cos(waveAngle) + particle.diameter + particleSpeed) * 0.5;
                            particle.tilt = Math.sin(particle.tiltAngle) * 15;
                        }
                        if (particle.x > width + 20 || particle.x < -20 || particle.y > height) {
                            if (streamingConfetti && particles.length <= maxParticleCount)
                                resetParticle(particle, width, height);
                            else {
                                particles.splice(i, 1);
                                i--;
                            }
                        }
                    }
                }
            })();

    </script>

    
    
</body>
</html>